#
# Conditional build:
%bcond_without	ocaml_opt	# skip building native optimized binaries (bytecode is always built)

# not yet available on x32 (ocaml 4.02.1), remove when upstream will support it
%ifnarch %{ix86} %{x8664} %{arm} aarch64 ppc sparc sparcv9
%undefine	with_ocaml_opt
%endif

%define		module	zarith
Summary:	Zarith: arbitrary-precision integers
Summary(pl.UTF-8):	Zarith - liczby całkowite dowolnej precyzji
Name:		ocaml-zarith
Version:	1.12
Release:	4
License:	LGPL v2 with linking exception
Group:		Applications/Math
#Source0Download: https://github.com/ocaml/Zarith/releases
Source0:	https://github.com/ocaml/Zarith/archive/release-%{version}/Zarith-%{version}.tar.gz
# Source0-md5:	bf368f3d9e20b6b446d54681afc05a04
URL:		http://github.com/ocaml/Zarith
BuildRequires:	bash
BuildRequires:	gmp-devel
BuildRequires:	ocaml >= 3.12.1
BuildRequires:	ocaml-findlib
BuildRequires:	perl-base
%requires_eq	ocaml-runtime
# does not work on x32 because sizeof(intnat) != sizeof(mp_limb_t) (4 != 8)
ExclusiveArch:	%{ix86} %{x8664} %{arm} aarch64 ppc sparc sparcv9
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The Zarith library implements arithmetic and logical operations over
arbitrary-precision integers. It uses GMP to efficiently implement
arithmetic over big integers. Small integers are represented as Caml
unboxed integers, for speed and space economy.

%description -l pl.UTF-8
Biblioteka Zarith implementuje operacje arytmetyczne i logiczne na
liczbach całkowitych dowolnej precyzji. Wykorzystuje gmp do wydajnej
arytmetyki na dużych liczbach całkowitych. Małe liczby całkowite są
reprezentowane jako nieograniczone liczby całkowite Camla, aby zyskać
na szybkości i rozmiarze.

%package devel
Summary:	Zarith library development files
Summary(pl.UTF-8):	Pliki programistyczne biblioteki Zarith
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
%requires_eq	ocaml

%description devel
This package contains files needed to develop OCaml programs using
Zarith library.

%description devel -l pl.UTF-8
Ten pakiet zawiera pliki potrzebne do tworzenia programów w OCamlu
przy użyciu biblioteki Zarith.

%prep
%setup -q -n Zarith-release-%{version}

%build
CC="%{__cc}" \
CFLAGS="%{rpmcflags}" \
./configure \
	-installdir $RPM_BUILD_ROOT%{_libdir}/ocaml \
	-gmp

%{__make} -j1

%install
rm -rf $RPM_BUILD_ROOT
export OCAMLFIND_DESTDIR=$RPM_BUILD_ROOT%{_libdir}/ocaml
install -d $OCAMLFIND_DESTDIR $OCAMLFIND_DESTDIR/stublibs

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_libdir}/ocaml/

# not required with system package manager
%{__rm} $RPM_BUILD_ROOT%{_libdir}/ocaml/stublibs/*.so.owner

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc Changes LICENSE README.md
%attr(755,root,root) %{_libdir}/ocaml/stublibs/dllzarith.so
%dir %{_libdir}/ocaml/%{module}
%{_libdir}/ocaml/%{module}/META
%if %{with ocaml_opt}
%attr(755,root,root) %{_libdir}/ocaml/%{module}/zarith.cmxs
%endif

%files devel
%defattr(644,root,root,755)
%{_libdir}/ocaml/%{module}/*.cm[axi]
%{_libdir}/ocaml/%{module}/*.mli
%{_libdir}/ocaml/%{module}/*.cmti
%{_libdir}/ocaml/%{module}/libzarith.a
%{_libdir}/ocaml/%{module}/zarith.h
%if %{with ocaml_opt}
%{_libdir}/ocaml/%{module}/zarith.a
%{_libdir}/ocaml/%{module}/zarith.cmxa
%endif
%changelog
* Sun Mar 28 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ocaml-zarith.git;a=log;h=master

* Sun Mar 28 2021 Jan Rękorajski <baggins@pld-linux.org> 37911d7
- no go on x32
- rel 4

* Sat Mar 27 2021 Jan Rękorajski <baggins@pld-linux.org> 82ded54
- update META file location
- rel 3

* Sun Mar 21 2021 Jan Rękorajski <baggins@pld-linux.org> 5c4f80f
- leave META where dune wants it
- rel 2

* Sun Mar 21 2021 Jan Rękorajski <baggins@pld-linux.org> f34269d
- up to 1.12

* Sat Dec 28 2019 Jakub Bogusz <qboosh@pld-linux.org> 41878b5
- added x32 patch (adjust asm arch detection for x32 ABI); release 2

* Sat Dec 28 2019 Jakub Bogusz <qboosh@pld-linux.org> 7f4ec68
- new URLs, updated to 1.9.1

* Mon Jun 05 2017 Jan Rękorajski <baggins@pld-linux.org> e0f0490
- up to 1.4.1

* Mon Jun 05 2017 Jan Rękorajski <baggins@pld-linux.org> dcde8a4
- rebuild with ocaml 4.04.1
- release 5 (by relup.sh)

* Mon Mar 21 2016 Jan Rękorajski <baggins@pld-linux.org> 7c20c9f
- release 4 (by relup.sh)

* Sat Jul 25 2015 Jan Rękorajski <baggins@pld-linux.org> 60665bd
- disable parallel build

* Sat Jul 25 2015 Jan Rękorajski <baggins@pld-linux.org> 67c93bb
- cleanup opt bcond
- rel 3

* Sun Nov 16 2014 Jan Rękorajski <baggins@pld-linux.org> 6feb2fd
- rebuild with ocaml 4.02
- release 2 (by relup.sh)

* Wed Apr 30 2014 Jan Rękorajski <baggins@pld-linux.org> 62d2504
- fix package name

* Wed Apr 30 2014 Jan Rękorajski <baggins@pld-linux.org> 2581d7f
- new

